'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

exports.default = function (ComponentStyle) {
  var createStyledComponent = function createStyledComponent(tagetEl, cssRules, props) {
    if (tagetEl !== null && (typeof targetEl === 'undefined' ? 'undefined' : _typeof(targetEl)) === 'object') {
      var mergedProps = Object.assign({}, tagetEl.keepProps, props);
      return createStyledComponent(tagetEl.tagName, tagetEl.cssRules.concat(cssRules), mergedProps);
    }

    var componentStyle = new ComponentStyle(cssRules);
    var StyledComponent = {
      props: props,
      data: function data() {
        return {
          generatedClassName: ''
        };
      },
      render: function render(createElement) {
        return createElement(tagetEl, {
          class: [this.generatedClassName]
        }, this.$slots.default);
      },
      methods: {
        generateAndInjectStyles: function generateAndInjectStyles(componentProps) {
          return componentStyle.generateAndInjectStyles(componentProps);
        }
      },
      mounted: function mounted() {
        var componentProps = Object.assign({}, this.$props);
        this.generatedClassName = this.generateAndInjectStyles(componentProps);
      }
    };

    StyledComponent.tagName = tagetEl;
    StyledComponent.cssRules = cssRules;
    StyledComponent.keepProps = props;

    return StyledComponent;
  };

  return createStyledComponent;
};

module.exports = exports['default'];